See <https://trac.macports.org/ticket/59992>.

--- include/unctrl.h.in.orig	2020-02-03 10:34:34
+++ include/unctrl.h.in	2023-12-09 17:23:33
@@ -42,6 +42,14 @@
 
 /* $Id: unctrl.h.in,v 1.12 2020/02/02 23:34:34 tom Exp $ */
 
+/* Work around issues with Apple's module map */
+#ifndef __building_module
+#define __building_module(x) 0
+#endif
+#if __building_module(Darwin)
+#include_next <unctrl.h>
+#else
+
 #ifndef NCURSES_UNCTRL_H_incl
 #define NCURSES_UNCTRL_H_incl	1
 
@@ -66,3 +74,5 @@ NCURSES_EXPORT(NCURSES_CONST char *) NCURSES_SP_NAME(u
 #endif
 
 #endif /* NCURSES_UNCTRL_H_incl */
+
+#endif /* __building_module(Darwin) */
--- include/ncurses_dll.h.in.orig	2020-09-06 03:58:47
+++ include/ncurses_dll.h.in	2023-12-09 17:26:09
@@ -28,6 +28,14 @@
  ****************************************************************************/
 /* $Id: ncurses_dll.h.in,v 1.17 2020/09/05 17:58:47 juergen Exp $ */
 
+/* Work around issues with Apple's module map */
+#ifndef __building_module
+#define __building_module(x) 0
+#endif
+#if __building_module(Darwin)
+#include_next <ncurses_dll.h>
+#else
+
 #ifndef NCURSES_DLL_H_incl
 #define NCURSES_DLL_H_incl 1
 
@@ -97,3 +105,5 @@
 #endif
 
 #endif /* NCURSES_DLL_H_incl */
+
+#endif /* __building_module(Darwin) */
--- include/curses.h.in.orig	2021-09-25 02:07:37
+++ include/curses.h.in	2023-12-09 17:32:22
@@ -34,6 +34,14 @@
  ****************************************************************************/
 
 /* $Id: curses.h.in,v 1.277 2021/09/24 16:07:37 tom Exp $ */
+
+/* Work around issues with Apple's module map */
+#ifndef __building_module
+#define __building_module(x) 0
+#endif
+#if __building_module(Darwin)
+#include_next <ncurses.h>
+#else
 
 #ifndef __NCURSES_H
 #define __NCURSES_H
--- include/curses.tail.orig	2021-03-21 02:49:25
+++ include/curses.tail	2023-12-09 17:28:51
@@ -195,3 +195,5 @@ extern GCC_NORETURN NCURSES_EXPORT(void) exit_curses (
 #endif
 
 #endif /* __NCURSES_H */
+
+#endif /* __building_module(Darwin) */
